/*
 * Linker script for PIC32MZ firmware.
 */
MEMORY
{
  flash  (rx)   : ORIGIN = 0x9fc00000,	LENGTH = 64K-64
  devcfg (r)    : ORIGIN = 0x9fc0ffc0,	LENGTH = 16
  devsign(r)    : ORIGIN = 0x9fc0ffe0,	LENGTH = 16
  prog   (rx)   : ORIGIN = 0x9d000000,	LENGTH = 2048K
  ram    (rw!x) : ORIGIN = 0xa0000000,	LENGTH = 512K
}

/* higher address of the user mode stack */
_estack = ORIGIN(ram) + LENGTH(ram);

SECTIONS
{

  /* Device configuration.  */
  .devcfg       :
  {
    *(.config3)
    *(.config2)
    *(.config1)
    *(.config0)
  } > devcfg


}