#ifndef _UART_H    /* Guard against multiple inclusion */
#define _UART_H

    typedef struct _example_struct_t 
    {
        int some_number;
        
    } example_struct_t;

#define SYSCLK 200000000L
#define PBCLK2 100000000L
#define Baud2BRG(desired_baud) ((PBCLK2/(16*desired_baud))-1)

    /*
 * UART Control and status register.
 */
#define PIC32_USTA_URXDA        0x00000001 /* Receive Data Available (read-only) */
#define PIC32_USTA_OERR         0x00000002 /* Receive Buffer Overrun */
#define PIC32_USTA_FERR         0x00000004 /* Framing error detected (read-only) */
#define PIC32_USTA_PERR         0x00000008 /* Parity error detected (read-only) */
#define PIC32_USTA_RIDLE        0x00000010 /* Receiver is idle (read-only) */
#define PIC32_USTA_ADDEN        0x00000020 /* Address Detect mode */
#define PIC32_USTA_URXISEL      0x000000C0 /* Bitmask: receive interrupt is set when... */
#define PIC32_USTA_URXISEL_NEMP	0x00000000 /* ...receive buffer is not empty */
#define PIC32_USTA_URXISEL_HALF	0x00000040 /* ...receive buffer becomes 1/2 full */
#define PIC32_USTA_URXISEL_3_4	0x00000080 /* ...receive buffer becomes 3/4 full */
#define PIC32_USTA_TRMT         0x00000100 /* Transmit shift register is empty (read-only) */
#define PIC32_USTA_UTXBF        0x00000200 /* Transmit buffer is full (read-only) */
#define PIC32_USTA_UTXEN        0x00000400 /* Transmit Enable */
#define PIC32_USTA_UTXBRK       0x00000800 /* Transmit Break */
#define PIC32_USTA_URXEN        0x00001000 /* Receiver Enable */
#define PIC32_USTA_UTXINV       0x00002000 /* Transmit Polarity Inversion */
#define PIC32_USTA_UTXISEL      0x0000C000 /* Bitmask: TX interrupt is generated when... */
#define PIC32_USTA_UTXISEL_1	0x00000000 /* ...the transmit buffer contains at least one empty space */
#define PIC32_USTA_UTXISEL_ALL	0x00004000 /* ...all characters have been transmitted */
#define PIC32_USTA_UTXISEL_EMP	0x00008000 /* ...the transmit buffer becomes empty */
#define PIC32_USTA_ADDR         0x00FF0000 /* Automatic Address Mask */
#define PIC32_USTA_ADM_EN       0x01000000 /* Automatic Address Detect */

    
void Delay10uS(int num);

int UART1Configure( int desired_baud );

void SerialTransmit( char * str );    
    
#endif /* _UART_H */
